#region File Description
//-----------------------------------------------------------------------------
// File:      RadioButton.cs
// Namespace: WindowSystem
// Author:    Aaron MacDougall
//-----------------------------------------------------------------------------
#endregion

#region Using Statements
using System;
using Microsoft.Xna.Framework;
#endregion

namespace XNAWindowSystem
{
    /// <summary>
    /// RadioButton is exactly the same as the CheckBox control, except for
    /// different default graphics.
    /// </summary>
    public class RadioButton : CheckBox
    {
        #region Default Properties
        private static DefaultSixSkins defaultButtonSkin = new DefaultSixSkins(
            new Rectangle(1, 59, 15, 15),
            new Rectangle(17, 59, 15, 15),
            new Rectangle(33, 59, 15, 15),
            new Rectangle(1, 75, 15, 15),
            new Rectangle(17, 75, 15, 15),
            new Rectangle(33, 75, 15, 15)
            );
        #endregion

        #region Constructors
        /// <summary>
        /// Constructor.
        /// </summary>
        /// <param name="game">The currently running Game object.</param>
        /// <param name="guiManager">GUIManager that this control is part of.</param>
        public RadioButton(Game game, GUIManager guiManager)
            : base(game, guiManager)
        {
            #region Set Default Properties
            Button.SetSkinsFromDefaults(defaultButtonSkin);
            #endregion
        }
        #endregion
    }
}